/// Auto-generated neural net C Code header file by MemBrain V03.07.00.00

/*
--- License information and liability disclaimer ---
------------------
The source code exported by MemBrain including all supplementary source code
provided as part of the MemBrain installation is subject to licensing according
to the terms indicated in the license agreement that is displayed when
installing the MemBrain software.

You can also download and view this license agreement on the MemBrain
homepage (http://www.membrain-nn.de).

The terms of the license agreement do especially prohibit the commercial use of
any of the MemBrain source code items for a commercial purpose except the
user or company that intends to use the code in a commercial way is a
commercially registered MemBrain user and the owner of a corresponding commercial
MemBrain license key.

The MemBrain program and all associated supplementary software including but not
limited to the MemBrain DLL and all MemBrain generated source code are distributed
"as is". No warranty of any kind is expressed or implied. You use it at your own risk.
Thomas Jetter will not be liable for data loss, damages and loss of profits or
properties or any other kind of damages or loss caused by use or misuse of this
software.

Copyright 2003 - 2008 Thomas Jetter
*/


#ifndef _NEURAL_NET_DEF_H_
#define _NEURAL_NET_DEF_H_

#include "NN_Types.h"

/// types to optimize code according to net analysis
typedef	UINT8	T_NEURON_COUNT;

typedef	UINT8	T_LINK_LEN;

typedef	UINT8	T_OUT_IDX;

typedef	UINT8	T_FIRE_DELAY;

typedef	UINT8	T_LINK_IDX;

typedef	UINT8	T_IN_LINK_COUNT;

typedef	FLOAT32	T_ACT_FLOAT;

typedef	FLOAT32	T_NORM_FLOAT;

/// preprocessor directives to optimize code according to net analysis
#define	INPUT_NORMALIZATION	

#define	OUTPUT_NORMALIZATION	

#define	ACT_FUNC_LOGISTIC	


/// Normalization code needed
#define	NORMALIZATION	

/// The logistic exponent to be used
extern const FLOAT32 MB_EXP_LOG;

/// include definitions of neurons and links
#include "Neuron.h"
#include "NeuralLink.h"

/// Number of neurons in the input layer
#define	MB_IN_NEURON_COUNT	4

/// Number of hidden neurons in all other layers (including context layer)
#define	MB_HID_NEURON_COUNT	4

/// Number of neurons in the output layer
#define	MB_OUT_NEURON_COUNT	1

/// parameter array for all neurons
extern const SNeuronParms NEURON_PARMS[];

/// Additional parameters for all input neurons
extern const SInputNeuronParms NEURON_PARMS_INPUT[];

/// Additional parameters for all hidden neurons
extern const SHiddenNeuronParms NEURON_PARMS_HIDDEN[];

/// additional parameters of all output neurons
extern const SOutputNeuronParms NEURON_PARMS_OUTPUT[];

/// parameters of all links in the net
extern const SNeuralLinkParms NEURAL_LINK_PARMS[];

/// number of neurons in the whole net
#define MB_NEURON_COUNT   (MB_IN_NEURON_COUNT + MB_HID_NEURON_COUNT + MB_OUT_NEURON_COUNT)

#endif // #ifndef _NEURAL_NET_DEF_H_

